Index: src/uk/me/parabola/mkgmap/reader/osm/POIGeneratorHook.java
===================================================================
--- src/uk/me/parabola/mkgmap/reader/osm/POIGeneratorHook.java	(revision 3598)
+++ src/uk/me/parabola/mkgmap/reader/osm/POIGeneratorHook.java	(working copy)
@@ -366,24 +366,33 @@
 			if (r instanceof MultiPolygonRelation == false) {
 				continue;
 			}
-			// boundary relations may have a node with role admin_centre, if yes, use the 
-			// location of it
 			Node existingPOI = null;
-			if ("boundary".equals(r.getTag("type")) && "administrative".equals(r.getTag("boundary"))){
-				for (Entry<String, Element> pair : r.getElements()){
-					String role = pair.getKey();
-					Element el = pair.getValue(); 
+			for (Entry<String, Element> pair : r.getElements()){
+				String role = pair.getKey();
+				Element el = pair.getValue();
+				if (el instanceof Node){
 					if ("admin_centre".equals(role)){
-						if (el instanceof Node){
+						if ("boundary".equals(r.getTag("type")) && "administrative".equals(r.getTag("boundary"))){
+							// boundary relations may have a node with role admin_centre, if yes, use the 
+							// location of it
 							String bName = getName(r);
 							String pName = getName(el);
-							if (bName != null && bName.equals(pName))
+							if (bName != null && bName.equals(pName)){
 								existingPOI = (Node) el;
+								break;
+							}
 						}
-						break;
+					} else if ("label".equals(role)){
+						String mpName = getName(r);
+						String label = getName(el);
+						if (mpName.equals(label)){
+							existingPOI = (Node) el;
+							break;
+						}
 					}
 				}
 			}
+ 
 			Coord point;
 			if (existingPOI ==null)
 				point = ((MultiPolygonRelation)r).getCofG();
